'TILESWP.BAS is a quick & dirty QBasic tool to parse CrimsonFields source and replace the map tile codes
'
'To process multiple source, use a cmd file to copy source one file at a time to INPUT.SRC,
' call QWBasic to do the processing, and then grab the output.src before moving on to the next input file...
'
'
' The tile numbers to be swapped must be found in the file C:\QBASIC\tileswap.txt,
' one 'pair' per line, old tile, new tile. This is read in at the start.
'
' mapwidth = nn, mapheight = nn must exist (nn = 10 to 99)
' processing starts when [map-raw] is found in the input
'
CLEAR
'
' can't use the double-quote symbol (") in a line of qbasic code, so assign it to a variable in case we need it
q$ = CHR$(34)
'
OPEN "C:\QBASIC\INPUT.SRC" FOR INPUT AS #1
OPEN "C:\QBASIC\OUTPUT.SRC" FOR OUTPUT AS #2
OPEN "C:\QBASIC\TILESWAP.txt" FOR INPUT AS #3
OPEN "C:\QBASIC\SWAP.LOG" FOR OUTPUT AS #4
'
' Load the conversion array
'
'  (insert code here to check TILESWAP.txt #3 exists first)
'
'First value in the file = number of new tiles
DIM swpct AS INTEGER
INPUT #3, swpct
print #4, 'count = ', swpct
if swpct = 0 THEN goto XIT
'now get the codes (1 pair per line)
DIM swptiles(swpct,2) AS INTEGER
oldtile = 1
newtile = 2
'
FOR n=1 TO swpct
INPUT #3, swptiles(n,oldtile), swptiles(n,newtile)
print #4, 'pair, old = ',swptiles(n,oldtile), ' new = ',swptiles(n,newtile)
NEXT n
'
' Now start processing
' Get mapwidth & mapheight
'
getnext:
LINE INPUT #1, in$
PRINT #2, in$
Qpos = INSTR(in$, "mapwidth")
IF Qpos = 1 THEN ntiles = val (RIGHT$(in$,2))
'
Qpos = INSTR(in$, "mapheight")
IF Qpos = 1 THEN nlines = val (RIGHT$(in$,2))
'
Qpos = INSTR(in$, "[map-raw]")
IF Qpos = 0 THEN GOTO getnext
'
'check we have width & height
IF ntiles > 9 THEN GOTO NOK
PRINT #4, "Map width too small NTILES = ", ntiles
goto XIT
NOK:
IF nlines > 9 THEN GOTO LOK
PRINT #4, "Map Height too small NLINES = ", nlines
goto XIT
LOK:
'
DIM tiles(ntiles) AS INTEGER
' for each line
FOR L=1 TO nlines
'
' start by getting all the tiles in the current line
FOR n = 1 to ntiles
INPUT #1, tiles(n)
' bi2cf adds an extra comma at the end of each line.
' this restults in an extra spurious tile (ID '0') at the strat of the next
' if found, skip it
IF n = 1 THEN IF tiles(n) = 0 THEN INPUT #1, tiles(n)
NEXT n


'
' now check if any have to be swapped 
FOR tile = 1 TO ntiles
' if this is one of the (oldtile) it needs to be swapped for a (newtile)

n = 1
chkswp:
IF tiles(tile) = swptiles(n,oldtile) THEN GOTO swapt
IF n = swpct THEN GOTO noswap
n = n + 1
' keep looking
GOTO chkswp
' found it
swapt:
tiles(tile) = swptiles(n,newtile)
print #4, "swapped ", tiles(tile), " for "swptiles(n,newtile)
' stop looking when a swap is found, otherwise the (new) tile could be replaced a second time
noswap:
' found or not, continue with next tile in this line
NEXT tile
'
' Now output the current map line ..
'  Crimson Fields can't cope with 'spaces' in the [map-raw] ...
'  and QBasic is crap at formatting numbers (so no leading zeros) ...
'
FOR T=1 to ntiles-1
IF tiles(T) > 99 THEN PRINT #2, USING "###"; tiles(T); ELSE IF tiles(T) > 9 THEN PRINT #2, USING "0##"; tiles(T); ELSE PRINT #2, USING "00#"; tiles(T); 
PRINT #2, ",";
NEXT T
'finish the line
IF tiles(ntiles) > 99 THEN PRINT #2, USING "###"; tiles(ntiles) ELSE IF tiles(T) > 9 THEN PRINT #2, USING "0##"; tiles(ntiles) ELSE PRINT #2, USING "00#"; tiles(T)
' continue to next line
NEXT L
'
' OK map done, now add the rest of the i/p file to the o/p w/o changes
DO
LINE INPUT #1, in$
PRINT #2, in$
LOOP UNTIL EOF(1)
'
XIT:
'OK, that's it, exit back to the CMD prompt
CLOSE
' wait for close to flush the cache
SLEEP 1
' now exit
SYSTEM



